//	GetPass 7.1 - C_FILTER for F6FBB BBS Software
//  	Written by Marco Savegnago IW3FQG

#ifndef __GPMSG_H
#define __GPMSG_H

#include "tdef.h"

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <dir.h>

#define MAXLINELEN 1024

class TString
{

protected:

	char *psz_string;
	int   i_lenOfString;

public:

	TString ( const char * cpsz_msg = "");
	virtual ~TString();
	char*				setString(const char * cpsz_str);
	char* 			add( const char * cpsz_str);
	TString& 		operator +( const char * cpsz_msg);
	int 				compare (char *psz_str);
	char*				isStringInc(char *psz_str);
	int 				len();
	char*				getString();
	friend char*	strip_crlf (char *psz_str);
};

inline TString::len()
{
	return i_lenOfString;
}

inline char *TString::getString()
{
	return psz_string;
}

inline int TString::compare (char *psz_str)
{
	return ( 0 == strcmp ( psz_string, psz_str ) );
}

inline TString & TString::operator +( const char * cpsz_msg )
{
	add(cpsz_msg);
	return *this;
}

class Message
:
	public TString
{
	int  	i_messageNum;
public:
	Message();
	Message ( int i_num, const char * cpsz_msg = "");
	char* 	getMessage( bool b_stripCRLF = false );
	int 	getNum();
};

inline char * Message::getMessage( bool b_strip )
{
	return ( b_strip ) ? strip_crlf ( psz_string ) : psz_string;
}

inline int Message::getNum()
{
	return i_messageNum;
}

class PasswordString
:
	public TString
{
	char *psz_password;
	int  i_lenOfPasswordString;
	void setPasswordLenght();

public:
	PasswordString ( char * pwd = "");
	~PasswordString ();

	char *getPos ( int pos );
	char *setPasswordString(const char * psz_str);
	int lenOfPassword();
	int isWildPassword();
};

inline PasswordString::~PasswordString()
{
	delete[] psz_password;
}

inline int PasswordString::lenOfPassword()
{
	return i_lenOfPasswordString;
}

inline int PasswordString::isWildPassword()
{
	return ( * ( psz_string + strlen (psz_string) - 1 ) == '*' );
}

class MessageVect
{
protected:
	Message** theMessageVect;
	int  i_lenOfMessageVect;

public:
	MessageVect( int i_item );
	virtual ~MessageVect();
	char * getMessage( int i_slot , bool b_stripCRLF = false );
	char * operator [] ( int i_slot );
	void add( Message * & message );
};

inline void MessageVect::add( Message * & message )
{
	theMessageVect[ message -> getNum() ] = message;
}

inline char * MessageVect::getMessage( int i_slot, bool b_stripCRLF )
{
	return( ( char * ) ( theMessageVect[ i_slot ] ) -> getMessage( b_stripCRLF ) );
}


inline char * MessageVect::operator [] ( int i_slot )
{
	return( (char * ) ( theMessageVect[ i_slot ] ) -> getMessage( true ) );
}


class MessageFile
:
	public MessageVect
{
protected:
	char	sz_fname[MAXPATH];
public:
	MessageFile( const char*	psz_filename, int numslot );
	int readFile();
};


struct ConfigFile
:
	public MessageFile
{
	ConfigFile( char *filename, int numslot);
	char *getStrParam( int i_slot );
	bool getBoolParam( int i_slot );
	int getValueParam( int i_slot );
};

inline ConfigFile::ConfigFile( char * filename, int numslot )\
:
	MessageFile( filename, numslot )
	{
	}

inline char * ConfigFile::getStrParam( int i_slot )
{
	return getMessage( i_slot, true );
}

inline int ConfigFile::getValueParam( int i_slot )
{
	return ( atoi( getMessage( i_slot ) ) );
}

#endif //__GPMSG_H

